import PurgeFromJS from './index';

describe('PurgeFromJS', () => {
    const mockContent = `import { VNode, VNodeProperties } from "maquette";
    import { $, $$ } from "../base-styles";

    const cell = $$("td").borderBottom.borderRight.borderSilver.bgGray600.p1;
    const header = $$("th").borderBottom.borderGray;
    if (!data || data.length <= 0) {
      return $$("table").collapse.h();
    }
    return $$("table").fullWidth.collapse.h([]);
    /**
     * Panel
     * @param nodes
     */

    $.div.flex.flexRow.flexNowrap.itemsStretch.h(
      ...(mapper ? map(mapper)(items) : items)
    )
     $.div.p_3._bgBlack.textWhite.shadowLg.fontExtrabold.text_2xl.h(
      'Frets with React'
    ),
    export const Panel = (isHoriz?: boolean,
                          title?: string,
                          properties?: VNodeProperties,
                          ...nodes: Array<string | VNode>): VNode => {
      let node = $.div.panel._bgWhite.shadow.smP1.p3.my2.rounded.leftAlign.overflowAuto;
      const titleNode = $.div.h2.pb2.h([title || ""]);
      if (isHoriz) {
        if (title && title.length) {
          return node.leftAlign.h([
            titleNode,
            $.div.flex.alignMiddle.justifyCenter.h(nodes),
          ]);
        } else {
          node = node.flex.alignMiddle.justifyCenter;
        }
      }
      if (title) {
        nodes = [titleNode, ...nodes];
      }
      return node.h(properties, nodes);
    };
    return $.div.flex.flexColumn.h([
        $.div.bgSilver.p2.borderBottom.borderGray.shadow.flex.justifyBetween.Bold.h([
          $.div.h(["My FRETS App"]),
        ]),
        props.messages.length
          ? alert(props.messages) : "",
        $grid.h([
          $.div.col.col_2.smCol.smCol_12.pt2.h([Menu(props, false, actions)]),
          $.div.col.col_10.smCol.smCol_12.px2.h([
            (props.activeScreen === SampleScreens.Home)
              ? renderHome(props, actions, idField)
              : renderAbout(props, actions),
          ]),
        ]),
        $.input.maxWidth_1.h({

        })
        $Panel.white.mr_1.w_1_3.content.h(x))(
      md,

      return $$(this.selector).injectProps<HTMLLinkElement>(
      this.tag === 'a' ? { href: '#/' } : {}
    ).bgBlue_600.hoverBgBlue_800.border.borderBlue_900.textWhite

    $.input.flexGrow.w_2_3._bgWhite.border.roundedSm.borderGray_300.ml_2.p_1.textBlack.shadowInner
        .add(
          !valid
            ? $$().bgRed_100.borderRed_500.textRed_600.border.toString()
            : ''
        )
        .h({
          value: field.value,

    get dark(): BaseStyles {
      return $$(this.selector).bgGray_400.borderGray_500
    }
    $Btn.primary.mt_2.h('Log In')
    `;

    it('contains all the selectors', () => {
        const expected = [
            'max-width-1',
            'col-2',
            'col-10',
            'sm-col-12',
            'border-bottom',
            'collapse',
            'full-width',
            'border-right',
            'border-silver',
            'bg-gray600',
            'p1',
            'div',
            'panel',
            'bg-white',
            'shadow',
            'sm-p1',
            'p3',
            'my2',
            'rounded',
            'left-align',
            'overflow-auto',
            'div',
            'h2',
            'pb2',
            'h-title',
            'flex',
            'align-middle',
            'justify-center',
            'bg-black',
            'border-gray-500',
            'shadow-inner',
            'hover:bg-blue-800',
            'mt-2',
        ];
        const selectors = PurgeFromJS.extract(mockContent);
        expect(
            expected.every((x) => {
                var res = selectors.includes(x);
                if (!res) {
                    console.log("Didn't find " + x);
                }
                return res;
            })
        ).toBe(true);
    });
});
